unit dbConnection_u;

interface

uses
  Forms, SysUtils, Classes, DB, ADODB, StdCtrls, DBGrids, DBCtrls,
  Windows;

type
  TConnection = class(TObject)
  private
  public
    dbConnection: TADOConnection;
    dsrOne : TDataSource;
    tblOne : TADOTable;
    procedure dbConnect;
    procedure dbDisconnect;
    procedure RestoreDatabase(var GridOne: TDBGrid);
    procedure setupGrids(var GridOne: TDBGrid);
    procedure ResetTables(GridOne : TDBGrid);

end;

var
  MyForm: Tform;

implementation

{ TConnection }
uses Controls, Dialogs;

const
  DBFileName: String = 'CovidResearch.mdb';
  DBBackup: String = 'CovidResearchBackUp.mdb';
  Researchtable: string = 'Articles';

procedure TConnection.dbConnect;
begin
  dbConnection := TADOConnection.Create(MyForm);
  dbConnection.LoginPrompt := False;
  dbConnection.ConnectionString :=
    'Provider=Microsoft.Jet.OLEDB.4.0;' + 'Data Source=' + DBFileName + ';' +
    'Mode=ReadWrite;' + 'Persist Security Info=False;' +
    'Jet OLEDB:Database Password=*************';
  dbConnection.Provider := 'Provider=Microsoft.Jet.OLEDB.4.0;';
  dbConnection.Open;

  tblone := TADOTable.Create(MyForm);
  tblone.Connection := dbConnection;
  tblone.TableName := Researchtable;
  tblone.Open;
  tblone.Sort := 'Title ASC';
  tblone.First;
   dsrone := TDataSource.Create(MyForm);
  dsrone.DataSet := tblone;
 end;

procedure TConnection.dbDisconnect;
begin
  tblOne.Free;
  tblOne := nil;
  dbConnection.Close;
  dbConnection.Free;
  dbConnection := nil;
end;


procedure TConnection.ResetTables(GridOne: TDBGrid);
begin
  tblone.Free;
  tblone := nil;
  tblone := TADOTable.Create(MyForm);
  tblone.Connection := dbConnection;
  tblone.TableName := Researchtable;
  tblone.Open;
  tblone.Sort := 'Title ASC';
  tblone.First;
  dsrOne.DataSet := tblone;
  GridOne.datasource := dsrone;

end;

procedure TConnection.RestoreDatabase(var GridOne : TDBGrid);
var
  sMsg: string;
  bfail: boolean;
begin
  // restore the original data in database.
  sMsg := 'Are you sure you want to reset the database?';
  if MessageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    try
      Screen.Cursor := crHourGlass;
      try
        dbConnection.Close;
        tblone.Destroy;
        bfail := False;
        DeleteFile(PChar(DBFileName));
        CopyFile(PChar(DBBackup), PChar(DBFileName), bfail);
        dbConnect;
        setupGrids(GridOne);
        tblone.Open;
        tblone.Sort := 'Title ASC';
      except
        on E: Exception do
        begin
          Showmessage(E.Message);
        end;
      end;
    finally
      Screen.Cursor := crDefault;
    end;
    MessageDlg('Database reset complete.', mtInformation, [mbOK], 0);
  end; // if
end;


procedure TConnection.setupGrids(var GridOne : TDBGrid);
begin
    GridOne.datasource := dsrOne;
    gridone.columns[0].width := 250;
    gridone.columns[1].width := 100;
    gridone.columns[2].width := 180;
     gridone.columns[3].width := 40;
      gridone.columns[4].width := 100;
       gridone.columns[5].width := 50;
end;

end.
